Enumeration
  #file_open
  #file_save
  #file_comment
  #file_dasm
  #file_quit
  
  #opt_setaddr
  #opt_nobyte
  #opt_bytecomm
  #opt_bytefirst
  
  #mark_code
  #mark_byte
  #mark_word
EndEnumeration

Global filesize.l=-1
Global startaddr.l=0
Global cp$=GetCurrentDirectory()
Global bytestyle=#opt_bytefirst;#opt_nobyte
Enumeration
  #da
EndEnumeration
Enumeration
  #type_code
  #type_byte
  #type_word
EndEnumeration
; ///////////////////////////////////////////////////////////////////////////////
; /////// A Z80 disassembler - works under Win32 For now
; ////// Author : Matthew Porth
; ///// Copyright : 2004 - Matthew Porth - however - If you email me I'll let
; ////              you use it commerically Or non-comercially With no restrictions
; ///               accept you MUST contact me
; // Version 0.08 - another compile option jr cc, -1 decompiles To RST cc, $38
; //              - added compiler time option To switch between JP (HL) And JP HL
; // Version 0.07 - added output of 16 bit load targets (often memory addresses)
; // Version 0.06 - IXH/IXL And IYH/IYL swapped (H xlats2 I?H And L xlats2 I?L
; // Version 0.05 - change in ED LD/CP/IN/OUT logic
; // Version 0.04 - fixed ED LDI/CPI/INI/OUTI opcodes.
; // Version 0.03 - added forward decl of dis() (duh!)
; //              - swapped index byte Read And opcode Read in FD/DD+CB opcodes
; //              - fixed double opcode bug in single op statements e.g. HALT HALT
; //              - changed ixf/iyf To a single variable
; //              - more opcodes stored in arrays (DAA/SCF And CB group rotates)
; //              - fixed undoc DD/FD+CB opcodes (now prints "temp" reg properly)
; // Version 0.02 - acceptable aligning of mneumnonics (6 chars)
; //              - better calling conventions (still sucks though)
; //              - negative indices in IX/IY index modes printed properly
; //              - this header changed ;-)
; // Version 0.01 - horribly unfinished.
Global Dim jtargs.u(65536)
Global Dim dtargs.u(65536)

Global jt.u=0
Global dt.u=0

Global Dim types.a(65536)
Global Dim memory.a(65536)
Global ip.u=0
Global startip.u = 0
Global idx_off.a=0
Global idx_ix.a=2
Global idx_iy.a=3
Global idxmode.a = idx_off
Global idxbyte.a = 0

Global ipp.u
Declare doCB()
Declare doED()
Declare dis()

Global db$
Procedure.a getbyte()
  b.a=memory(ip)
  ip+1
  db$=db$+RSet(Hex(b),2,"0")+" "
  ProcedureReturn b
EndProcedure

Procedure getidxbyte()
  idxbyte = getbyte()
EndProcedure     

Procedure.u getword()
  w.u= (memory(ip)):ip+1
  db$=db$+RSet(Hex(w),2,"0")+" "
  db$=db$+RSet(Hex(memory(ip)),2,"0")+" "
  w.u=w|((memory(ip))<<8):ip+1
  ProcedureReturn w
EndProcedure

Procedure doDD()
  idxmode = idx_ix
  dis()
EndProcedure

Procedure doFD()
  idxmode = idx_iy
  dis()
EndProcedure

Procedure.l disp(ch.a)
  If ch&128
    d.l=-(ch!255+1)
  Else
    d.l=ch
  EndIf
  ProcedureReturn d.l
EndProcedure

Procedure.s by(bb.a)
  ProcedureReturn "$"+RSet(Hex(bb),2,"0")
EndProcedure
Procedure.s wo(ww.u)
  ProcedureReturn "$"+RSet(Hex(ww),4,"0")
EndProcedure

Procedure opcode(op.s)
  WindowEvent()
  
  Select bytestyle
    Case #opt_nobyte
      l$=RSet(Hex(startip),4,"0")+" "+op
    Case #opt_bytecomm
      l$=RSet(Hex(startip),4,"0")+" "+op+" ; "+db$
    Case #opt_bytefirst
      l$=RSet(Hex(startip),4,"0")+" "+RSet(db$,12," ")+"  "+op
  EndSelect
  ;l$=RSet(Hex(startip),4,"0")+" "+RSet(db$,12," ")+" "+op
  db$=""
  AddGadgetItem (#da, -1,l$)
  SetGadgetState(#da, CountGadgetItems(#da)-1)
EndProcedure

Procedure.s reg16(u.a)
  
  Select u
    Case 0:r16.s="BC"
    Case 1:r16.s="DE"
    Case 2:
      If idxmode = idx_ix
        r16.s="IX"
      ElseIf idxmode = idx_iy
        r16.s="IY"
      Else
        r16.s="HL"
      EndIf
    Case 3:r16.s="SP"
    Default:
      r16.s="error!"
  EndSelect
  ProcedureReturn r16
EndProcedure

Procedure.s gethl()
  ProcedureReturn reg16(2)
EndProcedure


Procedure.s cc(u.a)
  Select u
    Case 0: jc.s="NZ"
    Case 1: jc.s="Z"
    Case 2: jc.s="NC"
    Case 3: jc.s="C"
    Case 4: jc.s="PO"
    Case 5: jc.s="PE"
    Case 6: jc.s="P"
    Case 7: jc.s="M"
    Default:
      jc.s="cond poimi"
  EndSelect
  ProcedureReturn jc
EndProcedure


Procedure.s g0gxg7ops(u.a)
  g0.s="huj poimi"
  Select u
    Case 0: g0="RLCA"
    Case 1: g0="RRCA"
    Case 2: g0="RLA"
    Case 3: g0="RRA"
    Case 4: g0="DAA"
    Case 5: g0="CPL"
    Case 6: g0="SCF"
    Case 7: g0="CCF"
  EndSelect
  ProcedureReturn g0
EndProcedure

Procedure.s aluop(u.a)
  Select u
    Case 0:alu.s="ADD"
    Case 1:alu.s="ADC"
    Case 2:alu.s="SUB"
    Case 3:alu.s="SBC"
    Case 4:alu.s="AND"
    Case 5:alu.s="XOR"
    Case 6:alu.s="OR"
    Case 7:alu.s="CP"
    Default:alu.s="bad alu"
  EndSelect
  ProcedureReturn alu+" "
EndProcedure

Procedure.s reg8(u.a)
  Select u
    Case 0: r8.s="B"
    Case 1: r8.s="C"
    Case 2: r8.s="D"
    Case 3: r8.s="E"
    Case 4:
      If idxmode = idx_ix:r8.s="IXH"
      ElseIf idxmode = idx_iy:r8.s="IYH"
      Else
        r8.s="H"
      EndIf
    Case 5:
      If idxmode = idx_ix:r8.s="IXL"
      ElseIf idxmode = idx_iy:r8.s="IYL"
      Else
        r8.s="L"
      EndIf
    Case 6:
      If idxmode = idx_ix
        disp.l=disp(idxbyte)
        r8.s="(IX"
        If disp>=0
          r8+"+"+by(idxbyte)+")"
        Else
          r8+Str(disp)+")"
        EndIf
      ElseIf idxmode = idx_iy
        ;getidxbyte()
        disp.l=disp(idxbyte)
        r8.s="(IY"
        If disp>=0
          r8+"+"+by(idxbyte)+")"
        Else
          r8+Str(disp)+")"
        EndIf
      Else
        r8.s="(HL)"
      EndIf
    Case 7:
      r8.s="A"
    Default: r8.s="huj poimi"
  EndSelect
  ProcedureReturn r8
EndProcedure; }


; // non stack versions
Procedure.s reg16st(u.a)
  Select u
    Case 0:r16s.s="BC"
    Case 1:r16s.s="DE"
    Case 2:
      If idxmode = idx_ix
        r16s.s="IX"
      ElseIf idxmode = idx_iy
        r16s.s="IY"
      Else
        r16s.s="HL"
      EndIf
    Case 3:r16s.s="AF"
    Default:r16s.s="Bad stack"
  EndSelect
  ProcedureReturn r16s
EndProcedure; }

; // As above but DON'T add the idxmode to the subscript
Procedure.s reg8noidx(u.a)
  Select u
    Case 0:r8.s="B"
    Case 1:r8.s="C"
    Case 2:r8.s="D"
    Case 3:r8.s="E"
    Case 4:r8.s="H"
    Case 5:r8.s="L"
    Case 6:r8.s="(HL)"
    Case 7:r8.s="A"
    Default: r8.s="error"
  EndSelect
  ProcedureReturn r8
EndProcedure



Procedure dis()
  wt=types(ip)
  b.a = getbyte()
  ;Debug Str(ip)+":"+Str(wt)
  Select wt
    Case #type_byte
      If b>=32 And b<=127
        l$=";"+Chr(b)
      Else
        l$=""
      EndIf
      opcode("DEFB $"+RSet(Hex(b),2,"0")+l$)
    Case #type_word
      b_.a = getbyte()
      opcode("DEFW $"+RSet(Hex(b+b_*256),4,"0"))
    Case #type_code
  g0.a = b >> 6
  g1.a = (b >> 3) & 7
  g2.a = b & 7
  
  Select g0
    Case 0:
      Select g2
        Case 0:
          Select g1
            Case 0:opcode("NOP")
            Case 1:opcode("EX AF,AF'")
            Case 2:
              o.a = getbyte()
              jtargs(jt)=ip+disp(o):jt+1
              opcode("DJNZ "+wo(ip+disp(o)))
            Case 3:
              o.a = getbyte()
              jtargs(jt)=ip+disp(o):jt+1
              opcode( "JR "+wo (ip+disp(o) ) )
            Default:
              o.a = getbyte()
              opcode( "JR "+cc(g1-4)+","+wo(ip+disp(o)) )
          EndSelect
        Case 1:
          If g1 & 1
            opcode("ADD "+gethl()+","+reg16(g1 >> 1));
          Else
            addr.u=getword()
            dtargs(dt)= addr
            dt+1
            opcode("LD "+reg16(g1 >> 1)+","+wo(addr))
          EndIf                                      ;}
        Case 2:
          Select g1
            Case 0:opcode("LD (BC),A")
            Case 1:opcode("LD A,(BC)")
            Case 2:opcode("LD (DE),A")
            Case 3:opcode("LD A,(DE)")
            Case 4:
              addr.u=getword()
              dtargs(dt)= addr
              dt+1
              opcode("LD  ("+wo(addr)+"),"+gethl())
            Case 5:
              addr.u=getword()
              dtargs(dt)= addr
              dt+1
              opcode("LD "+gethl()+",("+wo(addr)+")")
            Case 6:
              addr.u=getword()
              dtargs(dt)= addr
              dt+1
              opcode("LD  ("+wo(addr)+"),A")
            Case 7:
              addr.u=getword()
              dtargs(dt)= addr
              dt+1
              opcode("LD  A,("+wo(addr)+")")
          EndSelect
        Case 3:
          If g1 & 1
            opcode("DEC "+reg16(g1 >> 1));
          Else
            opcode("INC "+reg16(g1 >> 1));
          EndIf
        Case 4:
          If g1 = 6 And idxmode <> idx_off
            getidxbyte()
          EndIf;}
          opcode("INC "+reg8(g1));
        Case 5:
          If g1 = 6 And idxmode <> idx_off
            getidxbyte()         ;
          EndIf                  ;}
          opcode("DEC "+reg8(g1));
        Case 6:
          If g1 = 6 And idxmode <> idx_off
            getidxbyte()
          EndIf
          opcode("LD "+reg8(g1)+","+by(getbyte()))
        Case 7: opcode(g0gxg7ops(g1))
      EndSelect
    Case 1:
      If g1 = 6 And g2 = 6
        opcode("HALT")
      Else
        If g2 = 6 And idxmode <> idx_off
          getidxbyte()
          opcode("LD "+reg8noidx(g1)+","+reg8(g2))
        ElseIf g1 = 6 And idxmode <> idx_off
          getidxbyte()
          opcode("LD "+reg8(g1)+","+reg8noidx(g2))
        Else
          opcode("LD "+reg8(g1)+","+reg8(g2));
        EndIf
      EndIf
    Case 2:
      ;!!!fix?
      If g2 = 6  And idxmode <> idx_off
        getidxbyte()
      EndIf
      
      If g1=0 Or g1=1 Or g1=3
        opcode(aluop(g1)+"A,"+reg8(g2));
      Else
        opcode(aluop(g1)+" "+reg8(g2));
      EndIf
    Case 3:
      Select g2
        Case 0:   opcode("RET "+cc(g1));
        Case 1:
          If (g1 & 1)
            If g1 = 1
              opcode("RET");
            ElseIf g1 = 3
              opcode("EXX");
            ElseIf g1 = 5
              If idxmode = idx_ix
                opcode("JP (IX)")
              ElseIf idxmode = idx_iy
                opcode("JP (IY)")
              Else
                opcode("JP (HL)")
              EndIf
            ElseIf g1 = 7
              opcode("LD SP,"+gethl());
            EndIf
          Else
            opcode("POP "+reg16st(g1 >> 1));
          EndIf
        Case 2:;ElseIf g2 = 2
          addr.u=getword()
          dtargs(jt)= addr
          jt+1
          opcode("JP "+cc(g1)+","+wo(addr)); addjtarg(getword()));
        Case 3:
          Select g1
            Case 0:;If (g1 == 0) {
              addr.u=getword()
              dtargs(jt)= addr
              jt+1
              opcode("JP "+wo(addr));, addjtarg(getword()));
            Case 1: doCB()
            Case 2:
              opcode("OUT ("+by(getbyte())+ "),A")
            Case 3:
              opcode("IN A,("+by(getbyte())+")")
            Case 4:
              opcode("EX (SP),"+gethl())
            Case 5:
              opcode("EX DE,HL")
            Case 6:
              opcode("DI")
            Case 7:
              opcode("EI")                       ;
          EndSelect
        Case 4:
          addr.u=getword()
          dtargs(jt)= addr
          jt+1
          opcode("CALL "+cc(g1)+","+wo(addr))
        Case 5:
          If g1 & 1
            Select g1
              Case 1:
                addr.u=getword()
                dtargs(jt)= addr
                jt+1
                opcode("CALL "+wo(addr))
              Case 3:doDD()
              Case 5:doED()
              Case 7:doFD()
            EndSelect
          Else
            opcode("PUSH "+reg16st(g1 >> 1));
          EndIf
        Case 6:
          If g1=0 Or g1=1 Or g1=3
            opcode(aluop(g1)+"A,"+by(getbyte()))
          Else
            opcode(aluop(g1)+by(getbyte()))
          EndIf
        Case 7:
          opcode("RST "+by(g1 * 8));
      EndSelect
  EndSelect
  EndSelect
EndProcedure

;char *cbrops[8] = { "RLC", "RRC", "RL", "RR", "SLA", "SRA", "SLL", "SRL" };
Procedure.s cbrops(u.a)
  cb.s="unk CB"
  Select u
    Case 0:cb="RLC"
    Case 1:cb="RRC"
    Case 2:cb="RL"
    Case 3:cb="RR"
    Case 4:cb="SLA"
    Case 5:cb="SRA"
    Case 6:cb="SLL"
    Case 7:cb="SRL"
  EndSelect
  ProcedureReturn cb
EndProcedure

Procedure doCB();void doCB(void) {
                ;If (idxmode != idx_off) getidxbyte();
  If idxmode <> idx_off
    getidxbyte();
  EndIf
  b.a = getbyte();
  g0.a = b >> 6  ;
  g1.a = (b >> 3) & 7;
  g2.a = b & 7       ;
  
  Select g0
    Case 0:;If (g0 == 0) {
      If (idxmode <> idx_off And g2 <> 6);If (idxmode != idx_off && (g2 != 6)) {
        opcode(cbrops(g1)+" "+reg8(6)+" "+reg8noidx(g2));
      Else
        opcode(cbrops(g1)+" "+reg8(g2));
      EndIf
    Case 1:;} Else If (g0 == 1) {
      If idxmode <> idx_off;(idxmode != idx_off)
        opcode("BIT "+Str(g1)+","+reg8(6));
      Else
        opcode("BIT "+Str(g1)+","+reg8(g2));
      EndIf                                ;}
    Case 2:                                ;Else If (g0 == 2) {
      If idxmode <> idx_off And g2 <> 6    ;(idxmode != idx_off && g2 != 6)
        opcode ("RES "+Str(g1)+","+reg8(6)+" "+reg8noidx(g2));
      Else
        opcode("RES "+Str(g1)+","+reg8(g2));
      EndIf                                ;}
    Case 3:                                ;Else If (g0 == 3) {
      If (idxmode <> idx_off And g2 <> 6)  ;(idxmode != idx_off && g2 != 6)
        opcode ("SET "+Str(g1)+","+reg8(6)+" "+reg8noidx(g2));
      Else
        opcode("SET "+Str(g1)+","+reg8(g2));
      EndIf
  EndSelect;}
           ;}
EndProcedure; }
            ; 
            ; char *edautoops[16] = { "LDI", "LDD", "LDIR", "LDDR", "CPI", "CPD", "CPIR", "CPDR",
            ;                         "INI", "IND", "INIR", "INDR", "OUTI", "OUTD", "OUTIR", "OUTDR" };
            ; 
Procedure.s edautoops(u.a)
  ed.s="ED unkn"
  Select u
    Case 0:ed.s="LDI"
    Case 1:ed.s="LDD"
    Case 2:ed.s="LDIR"
    Case 3:ed.s="LDDR"
    Case 4:ed.s="CPI"
    Case 5:ed.s="CPD"
    Case 6:ed.s="CPIR"
    Case 7:ed.s="CPDR"
    Case 8:ed.s="INI"
    Case 9:ed.s="IND"
    Case 10:ed.s="INIR"
    Case 11:ed.s="INDR"
    Case 12:ed.s="OUTI"
    Case 13:ed.s="OUTD"
    Case 14:ed.s="OUTIR"
    Case 15:ed.s="OUTDR"
  EndSelect
  ProcedureReturn ed
EndProcedure

Procedure doED(); void doED() {
  idxmode = idx_off;
                   ;      Debug "ED"
                   ;      End
                   ; 
  b.a = getbyte()  ;
  g0.a = b >> 6    ;
  g1.a = (b >> 3) & 7;
  g2.a = b & 7       ;
                     ; 
  Select g0
      ;     If (g0 == 0 || g0 == 3) opcode("NOP");
    Case 0,3: opcode("NOP") 
      
    Case 1:
      ;     If (g0 == 1) {
      Select g2
        Case 0:;         If (g2 == 0) {
               ;             If (g1 != 6) opcode("IN", reg8(g1), "(C)");
               ;             Else opcode("IN","(C)");
          If g1<>6
            opcode("IN "+reg8(g1)+",(C)")
          Else
            opcode("IN,(C);????????????????")
          EndIf
        Case 1:;         } Else If (g2 == 1) {
               ;             If (g1 != 6) opcode("OUT", "(C)", reg8(g1));
          If g1<>6
            opcode("OUT (C),"+reg8(g1))
          Else
            opcode("OUT (C),0;?????????????????")
          EndIf
          ;             Else opcode("OUT","(C)", byte(0));
        Case 2:;         } Else If (g2 == 2) {
               ;             If (g1 & 1) opcode("ADC", "HL", reg16(g1 >> 1));
               ;             Else opcode("SBC", "HL", reg16(g1 >> 1));
          If g1&1
            opcode("ADC HL,"+reg16(g1 >> 1))
          Else
            opcode("SBC HL,"+reg16(g1 >> 1))
          EndIf
        Case 3:;         } Else If (g2 == 3) {
               ;             If (g1 & 1) opcode("LD", reg16(g1 >> 1), getword(), true);
               ;             Else opcode("LD", getword(), reg16(g1>> 1), true);
          If g1&1
            opcode("LD "+reg16(g1 >> 1)+",("+wo(getword())+")")
          Else
            opcode( "LD ("+wo(getword())+"),"+reg16(g1>> 1) )
          EndIf
        Case 4:;         } Else If (g2 == 4) {
               ;             opcode("NEG");
          opcode("NEG")
        Case 5:;         } Else If (g2 == 5) {
               ;             If (g1 == 1) opcode("RETI");
               ;             Else opcode("RETN");
          If g1=1
            opcode("RETI")
          Else
            opcode("RETN")
          EndIf
        Case 6:;         } Else If (g2 == 6) {
               ;             g1 &= 3;
               ;             If (g1 > 0) g1--;
               ;             opcode("IM", g1);
          g1=g1&3
          If g1>0:g1-1:EndIf
          opcode("IM "+Str(g1))
        Case 7:;         } Else If (g2 == 7) {
          Select g1
            Case 0: opcode("LD I,A");             If (g1 == 0) opcode("LD","I","A");
            Case 1: opcode("LD R,A");             If (g1 == 1) opcode("LD","R","A");
            Case 2: opcode("LD A,I");             If (g1 == 2) opcode("LD","A","I");
            Case 3: opcode("LD A,R");             If (g1 == 3) opcode("LD","A","R");
            Case 4: opcode("RRD")   ;             If (g1 == 4) opcode("RRD");
            Case 5: opcode("RLD")   ;             If (g1 == 5) opcode("RLD");
            Case 6: opcode("NOP")   ;             If (g1 == 6) opcode("NOP");
            Case 7:opcode("NOP")    ;             If (g1 == 7) opcode("NOP");
          EndSelect
      EndSelect;         }
    Case 2:    ;     } Else If (g0 == 2) {
      If g1&4 And (255-g2)&4;         If ((g1 & 4) & (~g2 & 4)) {
                            ;             opcode(edautoops[(g1 & 3) | (g2 << 2)]);
                            ;         }
        opcode(edautoops((g1 & 3) | (g2 << 2)))
      Else
        opcode("NOP")
      EndIf
  EndSelect;     }
EndProcedure; }


Procedure disasm(ipinit.u, ipmax.u)
jt.u=0
dt.u=0
idx_off.a=0
idx_ix.a=2
idx_iy.a=3
idxmode.a = idx_off
idxbyte.a = 0
db$=""
  ip = ipinit
  While (ip < ipmax)
    startip = ip
    idxmode = idx_off
    dis()
    If GetAsyncKeyState_(#VK_ESCAPE)&$8000
      Break
    EndIf
  Wend
EndProcedure

Procedure loadbin(f$)
  ;fix cp$
  filesize=FileSize(f$)
  If filesize>0
    If ReadFile(0,f$)
      curp.l=startaddr
      While Not Eof(0)
        memory(curp)=ReadAsciiCharacter(0)
        curp+1
        If curp>65535
          MessageRequester("Load file","End of memory")
          Break
        EndIf
      Wend
      CloseFile(0)
    Else
      filesize=-1
      MessageRequester("Load file","Open error:"+f$)
    EndIf
    
  EndIf
EndProcedure

Procedure setcheckm()
  For i=#opt_nobyte To #opt_bytefirst
    If i=bytestyle
      che=1
    Else
      che=0
    EndIf
    SetMenuItemState(0,i,che)
  Next i
EndProcedure

Procedure settype()
  For i=0 To 65535
    types(i)=#type_code
  Next i
EndProcedure

Procedure markpos(type)
  itm=GetGadgetState(#da)
  If itm<>-1
    s$=Mid(GetGadgetItemText(#da,itm),1,4)
    types(Val("$"+s$))=type
  EndIf
EndProcedure


If OpenWindow(0, 0, 0, 640, 480, "Z80 disassembler 0.9a", #PB_Window_SystemMenu | #PB_Window_ScreenCentered|#PB_Window_MinimizeGadget)
  ;;    StringGadget(#da, 0,  0, 640, 460, "",#ES_MULTILINE|#ES_AUTOVSCROLL|#WS_VSCROLL|#WS_HSCROLL|#ESB_DISABLE_LEFT|#ESB_DISABLE_RIGHT)
  ListViewGadget(#da, 0,  0, 640, 460)
  
  EnableGadgetDrop(#da,#PB_Drop_Files, #PB_Drag_Copy)
  If LoadFont(1, "Courier", 12)
    SetGadgetFont(#da, FontID(1))
  EndIf
  
  settype()
  
  If CreateMenu(0, WindowID(0))
    MenuTitle("File")
    MenuItem(#file_open, "Open...")
    MenuItem(#file_save, "Save...")
    MenuItem(#file_dasm, "Disassemble")
    MenuItem(#file_comment, "Comment...")
    MenuBar()
    MenuItem(#file_quit, "Quit")
    
    MenuTitle("Option")
    MenuItem(#opt_setaddr, "Starting address...")
    MenuBar()
    MenuItem(#opt_bytefirst, "Byte after address")
    MenuItem(#opt_nobyte, "No bytes")
    MenuItem(#opt_bytecomm, "Byte as comments")
    setcheckm()
  EndIf
  
  If CreatePopupMenu(1)
    MenuItem(#mark_code, "Mark as code")
    MenuItem(#mark_byte, "Mark as byte")
    MenuItem(#mark_word, "Mark as word")
  EndIf
  
  Repeat 
    eve=WaitWindowEvent()
    If GetAsyncKeyState_(#VK_ESCAPE)&32768
      Break
    EndIf
    
    Select eve
      Case #PB_Event_Gadget
        Select EventGadget()
          Case #da
            itm=GetGadgetState(#da)
            If itm<>-1
              If EventType()=#PB_EventType_RightClick
                DisplayPopupMenu(1, WindowID(0))
              EndIf
            EndIf
        EndSelect
      Case #PB_Event_Menu
        Select EventMenu();----menu events
          Case #opt_nobyte,#opt_bytecomm,#opt_bytefirst
            bytestyle=EventMenu()
            setcheckm()
            
          Case #file_comment
      itm=GetGadgetState(#da)
  If itm<>-1
    d$=GetGadgetItemText(#da,itm)
    p=FindString(d$,";")
    c$=""
    If p
      c$=Mid(d$,p+1)
      d$=Mid(d$,1,p-1)
    EndIf
    I$ = InputRequester("Comment", "Make your comment:", c$)
    If I$<>""
      SetGadgetItemText(#da,itm,d$+";"+i$)
    EndIf
    
  EndIf
        
          Case #mark_code
            markpos(#type_code)
          Case #mark_byte
            markpos(#type_byte)
          Case #mark_word
            markpos(#type_word)

          Case #file_dasm
            If filesize<>-1
              ClearGadgetItems(#da)
              db$=""
              disasm(startaddr,filesize)
            Else
            EndIf
          Case #file_save
            hm.l= CountGadgetItems(#da)
            If hm
              Pattern$ = "Assembler file (*.asm)|*.asm|Listing (*.lst)|*.lst"
              File$ = SaveFileRequester("Please choose file to save", cp$, Pattern$, 0)
              If File$
                ;check extension
                Select SelectedFilePattern()
                  Case 0: ex$=".asm"
                  Case 1: ex$=".lst"
                  Default:ex$=".lst"
                EndSelect
              EndIf
              If LCase(Right(File$,4))<>ex$
                File$+ex$
              EndIf
              If CreateFile(0,File$)
                cp$=GetPathPart(File$)
                For i=0 To hm-1
                  WriteStringN(0,GetGadgetItemText(#da,i))
                Next i
                CloseFile(0)
              EndIf
            Else
              MessageRequester("Save file","Nothing to save!")
            EndIf
          Case #file_open
            Pattern$ = "All files (*.*)|*.*"
            File$ = OpenFileRequester("Please choose file to load", cp$, Pattern$, 0)
            If File$
              loadbin(File$)
            EndIf
            
            
          Case #opt_setaddr
            Input$ = InputRequester("Start Address", "Start from($-hex/dec):", Str(startaddr))
            ;Debug Input$
            If Input$ <> ""
              numb.l=10
              num$="0123456789"
              If Mid(Input$,1,1)="$" Or Mid(Input$,1,1)="#"
                numb=16
                num$="0123456789ABCDEF"
                Input$=Mid(Input$,2)
              EndIf
              res.l=0
              Input$=UCase(Input$)
              For i=1 To Len(Input$)
                ;Debug Mid(Input$,i,1)
                p=FindString(num$,Mid(Input$,i,1))
                If p
                  res=res*numb+p-1
                Else
                  res=-1
                  MessageRequester("Address","Wrong number!")
                  Break
                EndIf
              Next i
              If res<>-1
                startaddr=res
              EndIf
            EndIf
          Case #file_quit
            Break
        EndSelect
        
      Case #PB_Event_GadgetDrop
        Files$ = EventDropFiles()
        Files$ = StringField(Files$, 1, Chr(10))
;         fs.l=FileSize(Files$)
;         If fs>=0
;           If ReadFile(0,Files$)
;             ii.u=0
;             While Not Eof(0)
;               memory(ii)=ReadAsciiCharacter(0)
;               ii+1
;             Wend
;             CloseFile(0)
        loadbin(Files$)
            db$=""
            ClearGadgetItems(#da)
            disasm(startaddr,filesize)
            ;MessageRequester("z80dis","done")
;           Else
;             MessageRequester("Error","Error read "+Files$,#PB_MessageRequester_Ok )
;           EndIf
        ;EndIf
        
    EndSelect
  Until eve = #PB_Event_CloseWindow
EndIf

End
; IDE Options = PureBasic 5.30 (Windows - x86)
; CursorPosition = 802
; FirstLine = 771
; Folding = -----
; EnableUnicode
; EnableXP
; UseIcon = z80dis.ico
; Executable = z80dis.exe